<?php
/*
 *
 * Copyright 2012 Human Resource Information System
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * @since 2012
 * @author John Francis Mukulu <john.f.mukulu@gmail.com>
 *
 */
namespace Hris\FormBundle\Entity;

use Doctrine\ORM\EntityRepository;

/**
 * FieldOptionRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class FieldOptionRepository extends EntityRepository
{
    /**
     * Returns maximum sort for the field children collection
     *
     * @param integer $fieldId
     * @return integer
     */
    public function findMaxSort($fieldId)
    {
        $queryBuilder = $this->getEntityManager()->createQueryBuilder();
        $maxSort = $queryBuilder->select('MAX(fieldOption.sort)')
            ->from('HrisFormBundle:FieldOption','fieldOption')
            ->join('fieldOption.field','field')
            ->andWhere('field.id=:fieldid')
            ->setParameters(array('fieldid'=>$fieldId))
            ->getQuery()->getSingleScalarResult();

        return $maxSort;
    }
}
